org.apache.commons.math3.distribution

## Class GammaDistribution

- java.lang.Object
- - org.apache.commons.math3.distribution.AbstractRealDistribution
  - - org.apache.commons.math3.distribution.GammaDistribution

All Implemented Interfaces:
  java.io.Serializable, RealDistribution

    public class GammaDistribution
    extends AbstractRealDistribution

Implementation of the Gamma distribution.

Version:
  $Id: GammaDistribution.java 1422195 2012-12-15 06:45:18Z psteitz $
See Also:
  Gamma distribution (Wikipedia), Gamma distribution (MathWorld), Serialized Form

### Field Summary

Fields
`static double` `DEFAULT_INVERSE_ABSOLUTE_ACCURACY` Default inverse cumulative probability accuracy.
`private double` `densityPrefactor1` The constant value of `shape / scale * sqrt(e / (2 * pi * (shape + g + 0.5))) / L(shape)`, where `L(shape)` is the Lanczos approximation returned by `Gamma.lanczos(double)`.
`private double` `densityPrefactor2` The constant value of `shape * sqrt(e / (2 * pi * (shape + g + 0.5))) / L(shape)`, where `L(shape)` is the Lanczos approximation returned by `Gamma.lanczos(double)`.
`private double` `maxLogY` Upper bound on `log(y)` (`y = x / scale`) for the selection of the computation method in `density(double)`.
`private double` `minY` Lower bound on `y = x / scale` for the selection of the computation method in `density(double)`.
`private double` `scale` The scale parameter.
`private static long` `serialVersionUID` Serializable version identifier.
`private double` `shape` The shape parameter.
`private double` `shiftedShape` The constant value of `shape + g + 0.5`, where `g` is the Lanczos constant `Gamma.LANCZOS_G`.
`private double` `solverAbsoluteAccuracy` Inverse cumulative probability accuracy.

### Fields inherited from class org.apache.commons.math3.distribution.AbstractRealDistribution

`random, randomData, SOLVER_DEFAULT_ABSOLUTE_ACCURACY`

### Constructor Summary

Constructors
Constructor and Description
`GammaDistribution(double shape, double scale)` Creates a new gamma distribution with specified values of the shape and scale parameters.
`GammaDistribution(double shape, double scale, double inverseCumAccuracy)` Creates a new gamma distribution with specified values of the shape and scale parameters.
`GammaDistribution(RandomGenerator rng, double shape, double scale, double inverseCumAccuracy)` Creates a Gamma distribution.

### Method Summary

Methods
`double` `cumulativeProbability(double x)` For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X <= x)`.
`double` `density(double x)` Returns the probability density function (PDF) of this distribution evaluated at the specified point `x`.
`double` `getAlpha()` Deprecated. as of version 3.1, `getShape()` should be preferred. This method will be removed in version 4.0.
`double` `getBeta()` Deprecated. as of version 3.1, `getScale()` should be preferred. This method will be removed in version 4.0.
`double` `getNumericalMean()` Use this method to get the numerical value of the mean of this distribution.
`double` `getNumericalVariance()` Use this method to get the numerical value of the variance of this distribution.
`double` `getScale()` Returns the scale parameter of `this` distribution.
`double` `getShape()` Returns the shape parameter of `this` distribution.
`protected double` `getSolverAbsoluteAccuracy()` Returns the solver absolute accuracy for inverse cumulative computation.
`double` `getSupportLowerBound()` Access the lower bound of the support.
`double` `getSupportUpperBound()` Access the upper bound of the support.
`boolean` `isSupportConnected()` Use this method to get information about whether the support is connected, i.e.
`boolean` `isSupportLowerBoundInclusive()` Whether or not the lower bound of support is in the domain of the density function.
`boolean` `isSupportUpperBoundInclusive()` Whether or not the upper bound of support is in the domain of the density function.
`double` `sample()` This implementation uses the following algorithms:

### Methods inherited from class org.apache.commons.math3.distribution.AbstractRealDistribution

`cumulativeProbability, inverseCumulativeProbability, probability, probability, reseedRandomGenerator, sample`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### DEFAULT_INVERSE_ABSOLUTE_ACCURACY

    public static final double DEFAULT_INVERSE_ABSOLUTE_ACCURACY

Default inverse cumulative probability accuracy.

Since:
  2.1
See Also:
  Constant Field Values

#### serialVersionUID

    private static final long serialVersionUID

Serializable version identifier.

See Also:
  Constant Field Values

#### shape

    private final double shape

The shape parameter.

#### scale

    private final double scale

The scale parameter.

#### shiftedShape

    private final double shiftedShape

The constant value of `shape + g + 0.5`, where `g` is the Lanczos constant `Gamma.LANCZOS_G`.

#### densityPrefactor1

    private final double densityPrefactor1

The constant value of `shape / scale * sqrt(e / (2 * pi * (shape + g + 0.5))) / L(shape)`, where `L(shape)` is the Lanczos approximation returned by `Gamma.lanczos(double)`. This prefactor is used in `density(double)`, when no overflow occurs with the natural calculation.

#### densityPrefactor2

    private final double densityPrefactor2

The constant value of `shape * sqrt(e / (2 * pi * (shape + g + 0.5))) / L(shape)`, where `L(shape)` is the Lanczos approximation returned by `Gamma.lanczos(double)`. This prefactor is used in `density(double)`, when overflow occurs with the natural calculation.

#### minY

    private final double minY

Lower bound on `y = x / scale` for the selection of the computation method in `density(double)`. For `y <= minY`, the natural calculation overflows.

#### maxLogY

    private final double maxLogY

Upper bound on `log(y)` (`y = x / scale`) for the selection of the computation method in `density(double)`. For `log(y) >= maxLogY`, the natural calculation overflows.

#### solverAbsoluteAccuracy

    private final double solverAbsoluteAccuracy

Inverse cumulative probability accuracy.

### Constructor Detail

#### GammaDistribution

    public GammaDistribution(double shape,
                     double scale)
                      throws NotStrictlyPositiveException

Creates a new gamma distribution with specified values of the shape and scale parameters.

Parameters:
  `shape` - the shape parameter
  `scale` - the scale parameter
Throws:
  `NotStrictlyPositiveException` - if `shape <= 0` or `scale <= 0`.

#### GammaDistribution

    public GammaDistribution(double shape,
                     double scale,
                     double inverseCumAccuracy)
                      throws NotStrictlyPositiveException

Creates a new gamma distribution with specified values of the shape and scale parameters.

Parameters:
  `shape` - the shape parameter
  `scale` - the scale parameter
  `inverseCumAccuracy` - the maximum absolute error in inverse cumulative probability estimates (defaults to `DEFAULT_INVERSE_ABSOLUTE_ACCURACY`).
Throws:
  `NotStrictlyPositiveException` - if `shape <= 0` or `scale <= 0`.
Since:
  2.1

#### GammaDistribution

    public GammaDistribution(RandomGenerator rng,
                     double shape,
                     double scale,
                     double inverseCumAccuracy)
                      throws NotStrictlyPositiveException

Creates a Gamma distribution.

Parameters:
  `rng` - Random number generator.
  `shape` - the shape parameter
  `scale` - the scale parameter
  `inverseCumAccuracy` - the maximum absolute error in inverse cumulative probability estimates (defaults to `DEFAULT_INVERSE_ABSOLUTE_ACCURACY`).
Throws:
  `NotStrictlyPositiveException` - if `shape <= 0` or `scale <= 0`.
Since:
  3.1

### Method Detail

#### getAlpha

    @Deprecated
    public double getAlpha()

Deprecated. as of version 3.1, `getShape()` should be preferred. This method will be removed in version 4.0.
Returns the shape parameter of `this` distribution.

Returns:
  the shape parameter

#### getShape

    public double getShape()

Returns the shape parameter of `this` distribution.

Returns:
  the shape parameter
Since:
  3.1

#### getBeta

    @Deprecated
    public double getBeta()

Deprecated. as of version 3.1, `getScale()` should be preferred. This method will be removed in version 4.0.
Returns the scale parameter of `this` distribution.

Returns:
  the scale parameter

#### getScale

    public double getScale()

Returns the scale parameter of `this` distribution.

Returns:
  the scale parameter
Since:
  3.1

#### density

    public double density(double x)

Returns the probability density function (PDF) of this distribution evaluated at the specified point `x`. In general, the PDF is the derivative of the `CDF`. If the derivative does not exist at `x`, then an appropriate replacement should be returned, e.g. `Double.POSITIVE_INFINITY`, `Double.NaN`, or the limit inferior or limit superior of the difference quotient.

Parameters:
  `x` - the point at which the PDF is evaluated
Returns:
  the value of the probability density function at point `x`

#### cumulativeProbability

    public double cumulativeProbability(double x)

For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X <= x)`. In other words, this method represents the (cumulative) distribution function (CDF) for this distribution. The implementation of this method is based on:

- Chi-Squared Distribution, equation (9).
- Casella, G., & Berger, R. (1990). Statistical Inference. Belmont, CA: Duxbury Press.

Parameters:
  `x` - the point at which the CDF is evaluated
Returns:
  the probability that a random variable with this distribution takes a value less than or equal to `x`

#### getSolverAbsoluteAccuracy

    protected double getSolverAbsoluteAccuracy()

Returns the solver absolute accuracy for inverse cumulative computation. You can override this method in order to use a Brent solver with an absolute accuracy different from the default.

Overrides:
  `getSolverAbsoluteAccuracy` in class `AbstractRealDistribution`
Returns:
  the maximum absolute error in inverse cumulative probability estimates

#### getNumericalMean

    public double getNumericalMean()

Use this method to get the numerical value of the mean of this distribution. For shape parameter `alpha` and scale parameter `beta`, the mean is `alpha * beta`.

Returns:
  the mean or `Double.NaN` if it is not defined

#### getNumericalVariance

    public double getNumericalVariance()

Use this method to get the numerical value of the variance of this distribution. For shape parameter `alpha` and scale parameter `beta`, the variance is `alpha * beta^2`.

Returns:
  the variance (possibly `Double.POSITIVE_INFINITY` as for certain cases in `TDistribution`) or `Double.NaN` if it is not defined

#### getSupportLowerBound

    public double getSupportLowerBound()

Access the lower bound of the support. This method must return the same value as `inverseCumulativeProbability(0)`. In other words, this method must return

`inf {x in R | P(X <= x) > 0}`.

The lower bound of the support is always 0 no matter the parameters.

Returns:
  lower bound of the support (always 0)

#### getSupportUpperBound

    public double getSupportUpperBound()

Access the upper bound of the support. This method must return the same value as `inverseCumulativeProbability(1)`. In other words, this method must return

`inf {x in R | P(X <= x) = 1}`.

The upper bound of the support is always positive infinity no matter the parameters.

Returns:
  upper bound of the support (always Double.POSITIVE_INFINITY)

#### isSupportLowerBoundInclusive

    public boolean isSupportLowerBoundInclusive()

Whether or not the lower bound of support is in the domain of the density function. Returns true iff `getSupporLowerBound()` is finite and `density(getSupportLowerBound())` returns a non-NaN, non-infinite value.

Returns:
  true if the lower bound of support is finite and the density function returns a non-NaN, non-infinite value there

#### isSupportUpperBoundInclusive

    public boolean isSupportUpperBoundInclusive()

Whether or not the upper bound of support is in the domain of the density function. Returns true iff `getSupportUpperBound()` is finite and `density(getSupportUpperBound())` returns a non-NaN, non-infinite value.

Returns:
  true if the upper bound of support is finite and the density function returns a non-NaN, non-infinite value there

#### isSupportConnected

    public boolean isSupportConnected()

Use this method to get information about whether the support is connected, i.e. whether all values between the lower and upper bound of the support are included in the support. The support of this distribution is connected.

Returns:
  `true`

#### sample

    public double sample()

This implementation uses the following algorithms:

For 0 < shape < 1:
Ahrens, J. H. and Dieter, U., Computer methods for sampling from gamma, beta, Poisson and binomial distributions. Computing, 12, 223-246, 1974.

For shape >= 1:
Marsaglia and Tsang, A Simple Method for Generating Gamma Variables. ACM Transactions on Mathematical Software, Volume 26 Issue 3, September, 2000.

Specified by:
  `sample` in interface `RealDistribution`
Overrides:
  `sample` in class `AbstractRealDistribution`
Returns:
  random value sampled from the Gamma(shape, scale) distribution